package cz.muni.fi.pa165.common;

import org.mapstruct.Mapping;
import org.mapstruct.Mappings;
import org.springframework.data.domain.Page;

import java.util.List;

public interface BaseMapper<T extends BaseObject, S extends BaseObjectDto> {

    T fromDto(S dto);

    S toDto(T entity);

    List<S> toDtoList(List<T> entities);

    @Mappings({
            @Mapping(target = "total", expression = "java(source.getTotalElements())"),
            @Mapping(target = "page", expression = "java(source.getNumber())"),
            @Mapping(target = "pageSize", expression = "java(source.getSize())"),
            @Mapping(target = "items", expression = "java(toDtoList(source.getContent()))")
    })
    Result<S> toResult(Page<T> source);
}
