package cz.muni.fi.pa165.movie;

import cz.muni.fi.pa165.common.BaseObject;
import cz.muni.fi.pa165.common.StringListConverter;
import cz.muni.fi.pa165.image.ImageDo;
import jakarta.persistence.*;
import lombok.*;

import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
@Builder
@EqualsAndHashCode(callSuper = false)
@NoArgsConstructor
@AllArgsConstructor
@Entity
public class MovieDo extends BaseObject {

    @Column(nullable = false)
    private String title;

    private String description;

    @Column(nullable = false)
    private String director;

    @Convert(converter = StringListConverter.class)
    private List<String> actors = new ArrayList<>();

    @ElementCollection(targetClass = GenreEnum.class)
    @Enumerated(EnumType.STRING)
    private List<GenreEnum> genres = new ArrayList<>();

    @OneToMany(mappedBy = "movieId", cascade = CascadeType.ALL)
    private List<ImageDo> images = new ArrayList<>();

    @PrePersist @PostUpdate
    private void beforePersist() {
        for (ImageDo image : images) {
            image.setMovie(this);
        }
    }
}
