import requests
import json

movies_url = "http://localhost:8080/movies"


def setup_movies():
    print("------ setting up movies -------")

    image = {"caption": "Cover image", "stringData": "someBase64String"}

    create_movie("The Godfather", "A classic crime drama", "Francis Ford Coppola", ["SCIFI", "DRAMA"],
                 ["Marlon Brando", "Al Pacino", "James Caan"], [image])
    create_movie("The Godfather: Part II", "A sequel to the classic crime drama", "Francis Ford Coppola",
                 ["SCIFI", "DRAMA"], ["Al Pacino", "Robert De Niro", "Robert Duvall"], [image])
    create_movie("Inception", "A mind-bending thriller", "Christopher Nolan", ["ACTION", "SCIFI", "THRILLER"],
                 ["Leonardo DiCaprio", "Joseph Gordon-Levitt", "Ellen Page"], [image])
    create_movie("Pulp Fiction", "A classic crime movie", "Quentin Tarantino", ["SCIFI", "DRAMA"],
                 ["John Travolta", "Samuel L. Jackson", "Uma Thurman"], [image])
    create_movie("The Silence of the Lambs", "A psychological thriller", "Jonathan Demme",
                 ["SCIFI", "DRAMA", "THRILLER"], ["Jodie Foster", "Anthony Hopkins", "Lawrence A. Bonney"], [image])
    create_movie("The Lord of the Rings: The Fellowship of the Ring", "An epic fantasy adventure", "Peter Jackson",
                 ["FANTASY", "ACTION"], ["Elijah Wood", "Ian McKellen", "Viggo Mortensen"], [image])
    create_movie("The Avengers", "A superhero team-up movie", "Joss Whedon", ["ACTION", "SCIFI"],
                 ["Robert Downey Jr.", "Chris Evans", "Mark Ruffalo"], [image])
    create_movie("The Matrix", "A sci-fi action movie", "The Wachowskis", ["ACTION", "SCIFI"],
                 ["Keanu Reeves", "Laurence Fishburne", "Carrie-Anne Moss"], [image])
    
    movie1 = get_movie_by_title("The Godfather")
    movie2 = get_movie_by_title("The Godfather: Part II")
    movie3 = get_movie_by_title("Inception")
    movie4 = get_movie_by_title("Pulp Fiction")
    movie5 = get_movie_by_title("The Silence of the Lambs")
    movie6 = get_movie_by_title("The Lord of the Rings: The Fellowship of the Ring")
    movie7 = get_movie_by_title("The Avengers")
    movie8 = get_movie_by_title("The Matrix")
    
    return [movie1, movie2, movie3, movie4, movie5, movie6, movie7, movie8]


def create_movie(title, description, director, genres, actors, images):
    json_data = {"title": title,
                 "description": description,
                 "director": director,
                 "genres": genres,
                 "actors": actors,
                 "images": images
                 }
    response = requests.post(movies_url, json=json_data)
    if response.status_code == 200:
        print(f"Movie {title} created.")
    else:
        print(f"Error while creating movie {title}.")


def get_movie_by_title(title):
    response = requests.get(f"{movies_url}/title/{title}")
    if response.status_code == 200:
        print(f"Retrieved movie {title}.")
        return response.json()
    else:
        print(f"Error while retrieving movie {title}.")
        return None


def delete_all_movies():
    response = requests.delete(movies_url)
    if response.status_code == 200:
        print("Deleted all movies.")
    else:
        print("Error while deleting all movies")
