import requests
import json
from user_utils import *
from movie_utils import *
from rating_utils import *
from recommender_utils import *

core_url = "http://localhost:8080"


def main():
    clear_db()
    users = setup_users()
    movies = setup_movies()
    setup_ratings(users, movies)
    demonstrate_recommender_service(movies)


def clear_db():
    print("------ clearing DB -------")
    delete_all_ratings()
    delete_all_movies()
    delete_all_users()


if __name__ == "__main__":
    main()
